import sys
from ctypes import *
Dll = WinDLL("aimmslink.dll")


Dll.AimmsOpenProject.argtypes = [ c_char_p, c_char_p, POINTER(c_int), c_int, c_int, c_int, c_int ]
Dll.AimmsOpenProject.restype = c_int

Dll.AimmsCloseProject.argtypes = [c_int]
Dll.AimmsCloseProject.restype = c_int

Dll.AimmsRunProcedure.argtypes = [c_int, c_char_p, POINTER(c_int)]
Dll.AimmsRunProcedure.restype = c_int

Dll.AimmsAssignSet.argtypes = [c_int, c_char_p, c_int, POINTER(c_char_p), c_bool ]
Dll.AimmsAssignSet.restype = c_int

Dll.AimmsIntAssignIdentifier.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float) ]
Dll.AimmsIntAssignIdentifier.restype = c_int

Dll.AimmsIntAssignIdentifierDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_double) ]
Dll.AimmsIntAssignIdentifierDouble.restype = c_int

Dll.AimmsOrdAssignIdentifier.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_float) ]
Dll.AimmsOrdAssignIdentifier.restype = c_int

Dll.AimmsOrdAssignIdentifierDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_double) ]
Dll.AimmsOrdAssignIdentifierDouble.restype = c_int

Dll.AimmsIntAssignIdentifierSlice.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsIntAssignIdentifierSlice.restype = c_int

Dll.AimmsIntAssignIdentifierSliceDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsIntAssignIdentifierSliceDouble.restype = c_int

Dll.AimmsOrdAssignIdentifierSlice.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsOrdAssignIdentifierSlice.restype = c_int

Dll.AimmsOrdAssignIdentifierSliceDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_double), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsOrdAssignIdentifierSliceDouble.restype = c_int


Dll.AimmsIntRetrieveIdentifier.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float) ]
Dll.AimmsIntRetrieveIdentifier.restype = c_int

Dll.AimmsIntRetrieveIdentifierDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_double) ]
Dll.AimmsIntRetrieveIdentifierDouble.restype = c_int

Dll.AimmsOrdRetrieveIdentifier.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_float) ]
Dll.AimmsOrdRetrieveIdentifier.restype = c_int

Dll.AimmsOrdRetrieveIdentifierDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_double) ]
Dll.AimmsOrdRetrieveIdentifierDouble.restype = c_int

Dll.AimmsIntRetrieveIdentifierSlice.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsIntRetrieveIdentifierSlice.restype = c_int

Dll.AimmsIntRetrieveIdentifierSliceDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsIntRetrieveIdentifierSliceDouble.restype = c_int

Dll.AimmsOrdRetrieveIdentifierSlice.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_float), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsOrdRetrieveIdentifierSlice.restype = c_int

Dll.AimmsOrdRetrieveIdentifierSliceDouble.argtypes = [c_int, c_char_p, c_int, POINTER(c_int), POINTER(c_double), POINTER(POINTER(c_int)), POINTER(c_int) ]
Dll.AimmsOrdRetrieveIdentifierSliceDouble.restype = c_int



Dll.AimmsGetLastErrorMessage.argtypes = [POINTER(c_int), c_char_p]
Dll.AimmsGetLastErrorMessage.restype = c_int

class AimmsError(Exception):
    pass
    
def makeStringArray(strParamList):
    numParams    = len(strParamList)
    strArrayType = c_char_p * numParams
    strArray     = strArrayType()
    for i, param in enumerate(strParamList):
        strArray[i] = param
    return strArray

def makeIntArray(intParamList):
    numParams    = len(intParamList)
    intArrayType = c_int * numParams
    intArray     = intArrayType()
    for i, param in enumerate(intParamList):
        intArray[i] = param
    return intArray

def makeDoubleArray(doubleParamList):
    numParams    = len(doubleParamList)
    doubleArrayType = c_double * numParams
    doubleArray     = doubleArrayType()
    for i, param in enumerate(doubleParamList):
        doubleArray[i] = param
    return doubleArray
    
def makeFloatArray(floatParamList):
    numParams    = len(floatParamList)
    floatArrayType = c_float * numParams
    floatArray     = floatArrayType()
    for i, param in enumerate(floatParamList):
        floatArray[i] = param
    return floatArray
    
def reportAimmsError():
    bufLen = c_int(1024)
    buffer = create_string_buffer(bufLen.value)
    ret = Dll.AimmsGetLastErrorMessage(byref(bufLen), buffer)
    raise AimmsError(buffer.value)

def aimmsAssignSet( projectHandle, setName, setData ):
    ctype_setData = makeStringArray(setData)
    ret = Dll.AimmsAssignSet(projectHandle, setName, len(ctype_setData), ctype_setData, True);    
    if (ret != 0):
        reportAimmsError()

def aimmsOrdAssignIdentifier( projectHandle, name, cards, data):
    ctype_data = makeFloatArray(data)
    ctype_cards = makeIntArray(cards)
    ret = Dll.AimmsOrdAssignIdentifier(projectHandle, name, len(cards), ctype_cards, ctype_data)
    if (ret != 0):
        reportAimmsError()

def AimmsOrdRetrieveIdentifier(projectHandle, name, cards):
    totalSize = 1
    for i in cards:
        totalSize *= i
    ctype_data = (c_float * totalSize)()
    ctype_cards = makeIntArray(cards)
    ret = Dll.AimmsOrdRetrieveIdentifier(projectHandle, name, len(cards), ctype_cards, ctype_data)
    if (ret != 0):
        reportAimmsError()
    return ctype_data[:]


projectHandle = c_int()
aimmsPath = "C:\\Users\\Joris\\AppData\\Local\\AIMMS\IFA\\Aimms\\4.8.1.299-x64"
aimmsProject = "C:\\u\\s\\rapi\\aimms-link\\src\\NemsTestProject_converted\\NemsTestProject.aimms"
ret = Dll.AimmsOpenProject( aimmsPath, aimmsProject, byref(projectHandle), 30, 16, 1048576, 1048576 )
if (ret != 0):
    reportAimmsError()
try:
    aimmsAssignSet( projectHandle, "Sa", [ "one", "two" ] )
    aimmsAssignSet( projectHandle, "Sb", [ "one", "two" ] )
        
    cards = [2,2]
    aimmsOrdAssignIdentifier(projectHandle, "LA", cards, [1.0,2.0,3.0,4.0])    
    data = AimmsOrdRetrieveIdentifier(projectHandle, "LA", cards)
    print data
finally:
    Dll.AimmsCloseProject(projectHandle)
    


