#ifndef _INCLUDE_aimms_CallBack
#define _INCLUDE_aimms_CallBack

#include <string>
#include "aimms/ICallBack.h"

namespace aimms{

    //This implementation of the ICallBack 
    // *appends the name of the project to the messages,
    // *stores them in the ErrorCollector,  
    // *throws an InternalException if at least one of the messages indicates an error.

    //This implementation ignores the onDataChanged call.

    class CallBack : public ICallBack
    {
    public:
        CallBack(class ErrorCollector* ec, const char* projectName);
		virtual ~CallBack();

    public:
        virtual void onDataChanged(std::vector<class IData*>& ){}
		virtual void onMessages(std::vector<AimmsMessage>& messages );

    public:
        //The link implementation can detect errors as well, these are stored to the collector 
        //by means of the addError function
        void addError(const char* error);

    private:
        class ErrorCollector* m_Collector;
        std::string m_ProjectName;
    
    };

}


#endif