#ifndef _INCLUDE_aimms_ElementLevel
#define _INCLUDE_aimms_ElementLevel

#include "Level.h"

namespace aimms{

    class IElement;

    // This implementations of this abstract class handle the search in or iteration over a single index level
    class ElementLevel : public Level  
    {
    protected:
        ElementLevel(Level* parent, int card, IElement* elem) 
            : m_Parent(parent)
            , m_Card(card)
            , m_Element(elem)  
        {
        }           
        ~ElementLevel()
        {
            delete m_Parent;
        }

    protected:
        int m_Card;
        Level* m_Parent;
        IElement* m_Element;
    };
}
#endif