#include "ErrorCollector.h"
#include "aimms/AimmsMessage.h"

namespace aimms{

    ErrorCollector::ErrorCollector()
    {
    }
    ErrorCollector::~ErrorCollector()
    {
    }

    void ErrorCollector::addError(const char* error)
    {
        m_ErrorStack.push(error);
    }

    int ErrorCollector::getLastError(int* textBufferLen, char* textBuffer )
    {
        // if the errorstack is empty, the call to this function is illegal
        if (m_ErrorStack.size() == 0){
            if(*textBufferLen >=8 ){
                textBuffer = "No error";
                *textBufferLen = 8;
            }
            return AM_InvalidUse;
        }
        // the error is only cpoied and popped if it fits in the buffer
        int len = static_cast<int>(m_ErrorStack.top().length());
        if (*textBufferLen > len){
            memcpy(textBuffer, m_ErrorStack.top().c_str(), len);
            textBuffer[len] = 0;
            m_ErrorStack.pop();
        }
        // the needed/used  length is written in the textBufferLen
        *textBufferLen = len + 1;
        return AM_OK;
    }

}

