#include "IntegerSparseLevel.h"
#include <algorithm>
#include "aimms/IElement.h"

namespace aimms{
    
    IntegerSparseLevel::IntegerSparseLevel(Level* parent, int first, int last, IElement* elem, int slicecard, int* slices)
        : ElementLevel(parent, last  -first + 1, elem)
        , m_SliceCard(slicecard)
        , m_Slices(slices)
        , m_First(first)
    {
    }
    void IntegerSparseLevel::HandleSlice(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int nr = 0 ; nr < m_SliceCard; ++nr){
             m_Element->setIntLabel(m_Slices[nr]); 
             m_Parent->HandleSlice(m_Slices[nr] - m_First + slicenr);
         }
    }
    void IntegerSparseLevel::HandleSliceNoTuple(int slicenr) {
         slicenr = slicenr * m_Card;
         for(  int nr = 0 ; nr < m_SliceCard; ++nr){
                m_Parent->HandleSliceNoTuple(m_Slices[nr] - m_First + slicenr);
         }
    }
    void IntegerSparseLevel::Apply(const double& value, int slicenr)
    {
        int i = m_Element->getIntLabel();       
        int* pos = std::lower_bound(m_Slices, m_Slices + m_SliceCard, i);
        if (pos < m_Slices + m_SliceCard && *pos == i) {
            m_Parent->Apply(value, slicenr * m_Card + i - m_First);
        }
    }
}