#ifndef _INCLUDE_aimms_OrdinalSparseLevel
#define _INCLUDE_aimms_OrdinalSparseLevel

#include "ElementLevel.h"

namespace aimms{

    // A level that iterates the supplied ordinals of the domain set, assuming the datablock stores all ordinals 
    class OrdinalSparseLevel : public ElementLevel 
    {
        friend class Iterator;

    private:
        OrdinalSparseLevel(Level* parent, int card, IElement* elem, int slicecard, int* slices);
        virtual void HandleSliceNoTuple(int slicenr); 
        virtual void HandleSlice(int slicenr); 
        virtual void Apply(const double& value, int slicenr); 

    private:
        int m_SliceCard;
        int* m_Slices;
    };
}
#endif