#ifndef _INCLUDE_aimms_RetrieveDataLevel
#define _INCLUDE_aimms_RetrieveDataLevel

#include "ValueLevel.h"

namespace aimms{

    // This class handles the assignment of the current Aimms value to the right address
    template<typename T>
    class RetrieveDataLevel : public ValueLevel
    {
        template<typename T> friend class SliceRetriever;

    private:
        virtual void HandleSliceNoTuple(int slicenr) {
            m_Values[slicenr] = 0.0;
        }
        virtual void Apply(const double& value, int slicenr)
        {
            m_Values[slicenr] = (T)value;
        }
    private:
        T* m_Values; 
        RetrieveDataLevel(T* values)
            : m_Values(values)
        {  
        }
        virtual ~RetrieveDataLevel(){}
    };
}
#endif